Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/as.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -63,4 +63,5 @@
 #include <synch/mutex.h>
 #include <adt/list.h>
+#include <adt/btree.h>
 #include <proc/task.h>
 #include <proc/thread.h>
@@ -88,12 +89,8 @@
 as_operations_t *as_operations = NULL;
 
-/** Cache for as_t objects */
+/** Slab for as_t objects.
+ *
+ */
 static slab_cache_t *as_cache;
-
-/** Cache for as_page_mapping_t objects */
-static slab_cache_t *as_page_mapping_cache;
-
-/** Cache for used_space_ival_t objects */
-static slab_cache_t *used_space_ival_cache;
 
 /** ASID subsystem lock.
@@ -119,12 +116,4 @@
 static int as_areas_cmp(void *, void *);
 
-static void used_space_initialize(used_space_t *);
-static void used_space_finalize(used_space_t *);
-static void *used_space_getkey(odlink_t *);
-static int used_space_cmp(void *, void *);
-static used_space_ival_t *used_space_last(used_space_t *);
-static void used_space_remove_ival(used_space_ival_t *);
-static void used_space_shorten_ival(used_space_ival_t *, size_t);
-
 NO_TRACE static errno_t as_constructor(void *obj, unsigned int flags)
 {
@@ -149,10 +138,4 @@
 	as_cache = slab_cache_create("as_t", sizeof(as_t), 0,
 	    as_constructor, as_destructor, SLAB_CACHE_MAGDEFERRED);
-
-	as_page_mapping_cache = slab_cache_create("as_page_mapping_t",
-	    sizeof(as_page_mapping_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
-
-	used_space_ival_cache = slab_cache_create("used_space_ival_t",
-	    sizeof(used_space_ival_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 
 	AS_KERNEL = as_create(FLAG_AS_KERNEL);
@@ -541,149 +524,4 @@
 }
 
-/** Get key function for pagemap ordered dictionary.
- *
- * The key is the virtual address of the page (as_page_mapping_t.vaddr)
- *
- * @param odlink Link to as_pagemap_t.map ordered dictionary
- * @return Pointer to virtual address cast as @c void *
- */
-static void *as_pagemap_getkey(odlink_t *odlink)
-{
-	as_page_mapping_t *mapping;
-
-	mapping = odict_get_instance(odlink, as_page_mapping_t, lpagemap);
-	return (void *) &mapping->vaddr;
-}
-
-/** Comparison function for pagemap ordered dictionary.
- *
- * @param a Pointer to virtual address cast as @c void *
- * @param b Pointer to virtual address cast as @c void *
- * @return <0, =0, >0 if virtual address a is less than, equal to, or
- *         greater than b, respectively.
- */
-static int as_pagemap_cmp(void *a, void *b)
-{
-	uintptr_t va = *(uintptr_t *)a;
-	uintptr_t vb = *(uintptr_t *)b;
-
-	if (va < vb)
-		return -1;
-	else if (va == vb)
-		return 0;
-	else
-		return +1;
-}
-
-/** Initialize pagemap.
- *
- * @param pagemap Pagemap
- */
-NO_TRACE void as_pagemap_initialize(as_pagemap_t *pagemap)
-{
-	odict_initialize(&pagemap->map, as_pagemap_getkey, as_pagemap_cmp);
-}
-
-/** Finalize pagemap.
- *
- * Destroy any entries in the pagemap.
- *
- * @param pagemap Pagemap
- */
-NO_TRACE void as_pagemap_finalize(as_pagemap_t *pagemap)
-{
-	as_page_mapping_t *mapping = as_pagemap_first(pagemap);
-	while (mapping != NULL) {
-		as_pagemap_remove(mapping);
-		mapping = as_pagemap_first(pagemap);
-	}
-	odict_finalize(&pagemap->map);
-}
-
-/** Get first page mapping.
- *
- * @param pagemap Pagemap
- * @return First mapping or @c NULL if there is none
- */
-NO_TRACE as_page_mapping_t *as_pagemap_first(as_pagemap_t *pagemap)
-{
-	odlink_t *odlink;
-
-	odlink = odict_first(&pagemap->map);
-	if (odlink == NULL)
-		return NULL;
-
-	return odict_get_instance(odlink, as_page_mapping_t, lpagemap);
-}
-
-/** Get next page mapping.
- *
- * @param cur Current mapping
- * @return Next mapping or @c NULL if @a cur is the last one
- */
-NO_TRACE as_page_mapping_t *as_pagemap_next(as_page_mapping_t *cur)
-{
-	odlink_t *odlink;
-
-	odlink = odict_next(&cur->lpagemap, &cur->pagemap->map);
-	if (odlink == NULL)
-		return NULL;
-
-	return odict_get_instance(odlink, as_page_mapping_t, lpagemap);
-}
-
-/** Find frame by virtual address.
- *
- * @param pagemap Pagemap
- * @param vaddr Virtual address of page
- * @param rframe Place to store physical frame address
- * @return EOK on succcess or ENOENT if no mapping found
- */
-NO_TRACE errno_t as_pagemap_find(as_pagemap_t *pagemap, uintptr_t vaddr,
-    uintptr_t *rframe)
-{
-	odlink_t *odlink;
-	as_page_mapping_t *mapping;
-
-	odlink = odict_find_eq(&pagemap->map, &vaddr, NULL);
-	if (odlink == NULL)
-		return ENOENT;
-
-	mapping = odict_get_instance(odlink, as_page_mapping_t, lpagemap);
-	*rframe = mapping->frame;
-	return EOK;
-}
-
-/** Insert new page mapping.
- *
- * This function can block to allocate kernel memory.
- *
- * @param pagemap Pagemap
- * @param vaddr Virtual page address
- * @param frame Physical frame address
- */
-NO_TRACE void as_pagemap_insert(as_pagemap_t *pagemap, uintptr_t vaddr,
-    uintptr_t frame)
-{
-	as_page_mapping_t *mapping;
-
-	mapping = slab_alloc(as_page_mapping_cache, 0);
-	mapping->pagemap = pagemap;
-	odlink_initialize(&mapping->lpagemap);
-	mapping->vaddr = vaddr;
-	mapping->frame = frame;
-	odict_insert(&mapping->lpagemap, &pagemap->map, NULL);
-}
-
-/** Remove page mapping.
- *
- * @param mapping Mapping
- */
-NO_TRACE void as_pagemap_remove(as_page_mapping_t *mapping)
-{
-	odict_remove(&mapping->lpagemap);
-	slab_free(as_page_mapping_cache, mapping);
-}
-
 /** Remove reference to address space area share info.
  *
@@ -703,8 +541,14 @@
 		dealloc = true;
 
-		as_page_mapping_t *mapping = as_pagemap_first(&sh_info->pagemap);
-		while (mapping != NULL) {
-			frame_free(mapping->frame, 1);
-			mapping = as_pagemap_next(mapping);
+		/*
+		 * Now walk carefully the pagemap B+tree and free/remove
+		 * reference from all frames found there.
+		 */
+		list_foreach(sh_info->pagemap.leaf_list, leaf_link,
+		    btree_node_t, node) {
+			btree_key_t i;
+
+			for (i = 0; i < node->keys; i++)
+				frame_free((uintptr_t) node->value[i], 1);
 		}
 
@@ -717,5 +561,5 @@
 			    sh_info->backend_shared_data);
 		}
-		as_pagemap_finalize(&sh_info->pagemap);
+		btree_destroy(&sh_info->pagemap);
 		free(sh_info);
 	}
@@ -792,4 +636,5 @@
 	area->attributes = attrs;
 	area->pages = pages;
+	area->resident = 0;
 	area->base = *base;
 	area->backend = backend;
@@ -820,5 +665,5 @@
 		si->backend_shared_data = NULL;
 		si->backend = backend;
-		as_pagemap_initialize(&si->pagemap);
+		btree_create(&si->pagemap);
 
 		area->sh_info = si;
@@ -844,5 +689,5 @@
 	}
 
-	used_space_initialize(&area->used_space);
+	btree_create(&area->used_space);
 	odict_insert(&area->las_areas, &as->as_areas, NULL);
 
@@ -952,96 +797,111 @@
 
 		/*
-		 * Start TLB shootdown sequence.
-		 */
-
-		ipl_t ipl = tlb_shootdown_start(TLB_INVL_PAGES,
-		    as->asid, area->base + P2SZ(pages),
-		    area->pages - pages);
-
-		/*
 		 * Remove frames belonging to used space starting from
 		 * the highest addresses downwards until an overlap with
-		 * the resized address space area is found.
+		 * the resized address space area is found. Note that this
+		 * is also the right way to remove part of the used_space
+		 * B+tree leaf list.
 		 */
 		bool cond = true;
 		while (cond) {
-			used_space_ival_t *ival =
-			    used_space_last(&area->used_space);
-			assert(ival != NULL);
-
-			uintptr_t ptr = ival->page;
-			size_t pcount = ival->count;
-			size_t i = 0;
-
-			if (overlaps(ptr, P2SZ(pcount), area->base,
-			    P2SZ(pages))) {
-
-				if (ptr + P2SZ(pcount) <= start_free) {
+			assert(!list_empty(&area->used_space.leaf_list));
+
+			btree_node_t *node =
+			    list_get_instance(list_last(&area->used_space.leaf_list),
+			    btree_node_t, leaf_link);
+
+			if ((cond = (node->keys != 0))) {
+				uintptr_t ptr = node->key[node->keys - 1];
+				size_t node_size =
+				    (size_t) node->value[node->keys - 1];
+				size_t i = 0;
+
+				if (overlaps(ptr, P2SZ(node_size), area->base,
+				    P2SZ(pages))) {
+
+					if (ptr + P2SZ(node_size) <= start_free) {
+						/*
+						 * The whole interval fits
+						 * completely in the resized
+						 * address space area.
+						 */
+						break;
+					}
+
 					/*
-					 * The whole interval fits completely
-					 * in the resized address space area.
+					 * Part of the interval corresponding
+					 * to b and c overlaps with the resized
+					 * address space area.
 					 */
-					break;
+
+					/* We are almost done */
+					cond = false;
+					i = (start_free - ptr) >> PAGE_WIDTH;
+					if (!used_space_remove(area, start_free,
+					    node_size - i))
+						panic("Cannot remove used space.");
+				} else {
+					/*
+					 * The interval of used space can be
+					 * completely removed.
+					 */
+					if (!used_space_remove(area, ptr, node_size))
+						panic("Cannot remove used space.");
 				}
 
 				/*
-				 * Part of the interval corresponding to b and
-				 * c overlaps with the resized address space
-				 * area.
+				 * Start TLB shootdown sequence.
+				 *
+				 * The sequence is rather short and can be
+				 * repeated multiple times. The reason is that
+				 * we don't want to have used_space_remove()
+				 * inside the sequence as it may use a blocking
+				 * memory allocation for its B+tree. Blocking
+				 * while holding the tlblock spinlock is
+				 * forbidden and would hit a kernel assertion.
 				 */
 
-				/* We are almost done */
-				cond = false;
-				i = (start_free - ptr) >> PAGE_WIDTH;
-
-				/* Shorten the interval to @c i pages */
-				used_space_shorten_ival(ival, i);
-			} else {
+				ipl_t ipl = tlb_shootdown_start(TLB_INVL_PAGES,
+				    as->asid, area->base + P2SZ(pages),
+				    area->pages - pages);
+
+				for (; i < node_size; i++) {
+					pte_t pte;
+					bool found = page_mapping_find(as,
+					    ptr + P2SZ(i), false, &pte);
+
+					(void) found;
+					assert(found);
+					assert(PTE_VALID(&pte));
+					assert(PTE_PRESENT(&pte));
+
+					if ((area->backend) &&
+					    (area->backend->frame_free)) {
+						area->backend->frame_free(area,
+						    ptr + P2SZ(i),
+						    PTE_GET_FRAME(&pte));
+					}
+
+					page_mapping_remove(as, ptr + P2SZ(i));
+				}
+
 				/*
-				 * The interval of used space can be completely
-				 * removed.
+				 * Finish TLB shootdown sequence.
 				 */
-				used_space_remove_ival(ival);
+
+				tlb_invalidate_pages(as->asid,
+				    area->base + P2SZ(pages),
+				    area->pages - pages);
+
+				/*
+				 * Invalidate software translation caches
+				 * (e.g. TSB on sparc64, PHT on ppc32).
+				 */
+				as_invalidate_translation_cache(as,
+				    area->base + P2SZ(pages),
+				    area->pages - pages);
+				tlb_shootdown_finalize(ipl);
 			}
-
-			for (; i < pcount; i++) {
-				pte_t pte;
-				bool found = page_mapping_find(as,
-				    ptr + P2SZ(i), false, &pte);
-
-				(void) found;
-				assert(found);
-				assert(PTE_VALID(&pte));
-				assert(PTE_PRESENT(&pte));
-
-				if ((area->backend) &&
-				    (area->backend->frame_free)) {
-					area->backend->frame_free(area,
-					    ptr + P2SZ(i),
-					    PTE_GET_FRAME(&pte));
-				}
-
-				page_mapping_remove(as, ptr + P2SZ(i));
-			}
-
-		}
-
-		/*
-		 * Finish TLB shootdown sequence.
-		 */
-
-		tlb_invalidate_pages(as->asid,
-		    area->base + P2SZ(pages),
-		    area->pages - pages);
-
-		/*
-		 * Invalidate software translation caches
-		 * (e.g. TSB on sparc64, PHT on ppc32).
-		 */
-		as_invalidate_translation_cache(as,
-		    area->base + P2SZ(pages),
-		    area->pages - pages);
-		tlb_shootdown_finalize(ipl);
-
+		}
 		page_table_unlock(as, false);
 	} else {
@@ -1102,4 +962,5 @@
 
 	page_table_lock(as, false);
+
 	/*
 	 * Start TLB shootdown sequence.
@@ -1109,32 +970,34 @@
 
 	/*
-	 * Visit only the pages mapped by used_space.
-	 */
-	used_space_ival_t *ival = used_space_first(&area->used_space);
-	while (ival != NULL) {
-		uintptr_t ptr = ival->page;
-
-		for (size_t size = 0; size < ival->count; size++) {
-			pte_t pte;
-			bool found = page_mapping_find(as,
-			    ptr + P2SZ(size), false, &pte);
-
-			(void) found;
-			assert(found);
-			assert(PTE_VALID(&pte));
-			assert(PTE_PRESENT(&pte));
-
-			if ((area->backend) &&
-			    (area->backend->frame_free)) {
-				area->backend->frame_free(area,
-				    ptr + P2SZ(size),
-				    PTE_GET_FRAME(&pte));
+	 * Visit only the pages mapped by used_space B+tree.
+	 */
+	list_foreach(area->used_space.leaf_list, leaf_link, btree_node_t,
+	    node) {
+		btree_key_t i;
+
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t ptr = node->key[i];
+			size_t size;
+
+			for (size = 0; size < (size_t) node->value[i]; size++) {
+				pte_t pte;
+				bool found = page_mapping_find(as,
+				    ptr + P2SZ(size), false, &pte);
+
+				(void) found;
+				assert(found);
+				assert(PTE_VALID(&pte));
+				assert(PTE_PRESENT(&pte));
+
+				if ((area->backend) &&
+				    (area->backend->frame_free)) {
+					area->backend->frame_free(area,
+					    ptr + P2SZ(size),
+					    PTE_GET_FRAME(&pte));
+				}
+
+				page_mapping_remove(as, ptr + P2SZ(size));
 			}
-
-			page_mapping_remove(as, ptr + P2SZ(size));
-		}
-
-		used_space_remove_ival(ival);
-		ival = used_space_first(&area->used_space);
+		}
 	}
 
@@ -1154,6 +1017,8 @@
 	page_table_unlock(as, false);
 
-	used_space_finalize(&area->used_space);
+	btree_destroy(&area->used_space);
+
 	area->attributes |= AS_AREA_ATTR_PARTIAL;
+
 	sh_info_remove_reference(area->sh_info);
 
@@ -1391,7 +1256,19 @@
 	mutex_unlock(&area->sh_info->lock);
 
+	/*
+	 * Compute total number of used pages in the used_space B+tree
+	 */
+	size_t used_pages = 0;
+
+	list_foreach(area->used_space.leaf_list, leaf_link, btree_node_t,
+	    node) {
+		btree_key_t i;
+
+		for (i = 0; i < node->keys; i++)
+			used_pages += (size_t) node->value[i];
+	}
+
 	/* An array for storing frame numbers */
-	uintptr_t *old_frame = malloc(area->used_space.pages *
-	    sizeof(uintptr_t));
+	uintptr_t *old_frame = malloc(used_pages * sizeof(uintptr_t));
 	if (!old_frame) {
 		mutex_unlock(&area->lock);
@@ -1414,26 +1291,28 @@
 	size_t frame_idx = 0;
 
-	used_space_ival_t *ival = used_space_first(&area->used_space);
-	while (ival != NULL) {
-		uintptr_t ptr = ival->page;
-		size_t size;
-
-		for (size = 0; size < ival->count; size++) {
-			pte_t pte;
-			bool found = page_mapping_find(as, ptr + P2SZ(size),
-			    false, &pte);
-
-			(void) found;
-			assert(found);
-			assert(PTE_VALID(&pte));
-			assert(PTE_PRESENT(&pte));
-
-			old_frame[frame_idx++] = PTE_GET_FRAME(&pte);
-
-			/* Remove old mapping */
-			page_mapping_remove(as, ptr + P2SZ(size));
-		}
-
-		ival = used_space_next(ival);
+	list_foreach(area->used_space.leaf_list, leaf_link, btree_node_t,
+	    node) {
+		btree_key_t i;
+
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t ptr = node->key[i];
+			size_t size;
+
+			for (size = 0; size < (size_t) node->value[i]; size++) {
+				pte_t pte;
+				bool found = page_mapping_find(as,
+				    ptr + P2SZ(size), false, &pte);
+
+				(void) found;
+				assert(found);
+				assert(PTE_VALID(&pte));
+				assert(PTE_PRESENT(&pte));
+
+				old_frame[frame_idx++] = PTE_GET_FRAME(&pte);
+
+				/* Remove old mapping */
+				page_mapping_remove(as, ptr + P2SZ(size));
+			}
+		}
 	}
 
@@ -1465,20 +1344,22 @@
 	frame_idx = 0;
 
-	ival = used_space_first(&area->used_space);
-	while (ival != NULL) {
-		uintptr_t ptr = ival->page;
-		size_t size;
-
-		for (size = 0; size < ival->count; size++) {
-			page_table_lock(as, false);
-
-			/* Insert the new mapping */
-			page_mapping_insert(as, ptr + P2SZ(size),
-			    old_frame[frame_idx++], page_flags);
-
-			page_table_unlock(as, false);
-		}
-
-		ival = used_space_next(ival);
+	list_foreach(area->used_space.leaf_list, leaf_link, btree_node_t,
+	    node) {
+		btree_key_t i;
+
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t ptr = node->key[i];
+			size_t size;
+
+			for (size = 0; size < (size_t) node->value[i]; size++) {
+				page_table_lock(as, false);
+
+				/* Insert the new mapping */
+				page_mapping_insert(as, ptr + P2SZ(size),
+				    old_frame[frame_idx++], page_flags);
+
+				page_table_unlock(as, false);
+			}
+		}
 	}
 
@@ -1844,180 +1725,10 @@
 }
 
-/** Initialize used space map.
- *
- * @param used_space Used space map
- */
-static void used_space_initialize(used_space_t *used_space)
-{
-	odict_initialize(&used_space->ivals, used_space_getkey, used_space_cmp);
-	used_space->pages = 0;
-}
-
-/** Finalize used space map.
- *
- * @param used_space Used space map
- */
-static void used_space_finalize(used_space_t *used_space)
-{
-	assert(odict_empty(&used_space->ivals));
-	odict_finalize(&used_space->ivals);
-}
-
-/** Get first interval of used space.
- *
- * @param used_space Used space map
- * @return First interval or @c NULL if there are none
- */
-used_space_ival_t *used_space_first(used_space_t *used_space)
-{
-	odlink_t *odlink = odict_first(&used_space->ivals);
-
-	if (odlink == NULL)
-		return NULL;
-
-	return odict_get_instance(odlink, used_space_ival_t, lused_space);
-}
-
-/** Get next interval of used space.
- *
- * @param cur Current interval
- * @return Next interval or @c NULL if there are none
- */
-used_space_ival_t *used_space_next(used_space_ival_t *cur)
-{
-	odlink_t *odlink = odict_next(&cur->lused_space,
-	    &cur->used_space->ivals);
-
-	if (odlink == NULL)
-		return NULL;
-
-	return odict_get_instance(odlink, used_space_ival_t, lused_space);
-}
-
-/** Get last interval of used space.
- *
- * @param used_space Used space map
- * @return First interval or @c NULL if there are none
- */
-static used_space_ival_t *used_space_last(used_space_t *used_space)
-{
-	odlink_t *odlink = odict_last(&used_space->ivals);
-
-	if (odlink == NULL)
-		return NULL;
-
-	return odict_get_instance(odlink, used_space_ival_t, lused_space);
-}
-
-/** Find the first interval that contains addresses greater than or equal to
- * @a ptr.
- *
- * @param used_space Used space map
- * @param ptr Virtual address
- *
- * @return Used space interval or @c NULL if none matches
- */
-used_space_ival_t *used_space_find_gteq(used_space_t *used_space, uintptr_t ptr)
-{
-	odlink_t *odlink;
-	used_space_ival_t *ival;
-
-	/* Find last interval to start at address less than @a ptr */
-	odlink = odict_find_lt(&used_space->ivals, &ptr, NULL);
-	if (odlink != NULL) {
-		ival = odict_get_instance(odlink, used_space_ival_t,
-		    lused_space);
-
-		/* If the interval extends above @a ptr, return it */
-		if (ival->page + P2SZ(ival->count) > ptr)
-			return ival;
-
-		/*
-		 * Otherwise, if a next interval exists, it must match
-		 * the criteria.
-		 */
-		odlink = odict_next(&ival->lused_space, &used_space->ivals);
-	} else {
-		/*
-		 * No interval with lower base address, so if there is any
-		 * interval at all, it must match the criteria
-		 */
-		odlink = odict_first(&used_space->ivals);
-	}
-
-	if (odlink != NULL) {
-		ival = odict_get_instance(odlink, used_space_ival_t,
-		    lused_space);
-		return ival;
-	}
-
-	return NULL;
-}
-
-/** Get key function for used space ordered dictionary.
- *
- * The key is the virtual address of the first page
- *
- * @param odlink Ordered dictionary link (used_space_ival_t.lused_space)
- * @return Pointer to virtual address of first page cast as @c void *.
- */
-static void *used_space_getkey(odlink_t *odlink)
-{
-	used_space_ival_t *ival = odict_get_instance(odlink, used_space_ival_t,
-	    lused_space);
-	return (void *) &ival->page;
-}
-
-/** Compare function for used space ordered dictionary.
- *
- * @param a Pointer to virtual address of first page cast as @c void *
- * @param b Pointer to virtual address of first page cast as @c void *
- * @return Less than zero, zero, greater than zero if virtual address @a a
- *         is less than, equal to, greater than virtual address b, respectively.
- */
-static int used_space_cmp(void *a, void *b)
-{
-	uintptr_t va = *(uintptr_t *) a;
-	uintptr_t vb = *(uintptr_t *) b;
-
-	if (va < vb)
-		return -1;
-	else if (va == vb)
-		return 0;
-	else
-		return +1;
-}
-
-/** Remove used space interval.
- *
- * @param ival Used space interval
- */
-static void used_space_remove_ival(used_space_ival_t *ival)
-{
-	ival->used_space->pages -= ival->count;
-	odict_remove(&ival->lused_space);
-	slab_free(used_space_ival_cache, ival);
-}
-
-/** Shorten used space interval.
- *
- * @param ival Used space interval
- * @param count New number of pages in the interval
- */
-static void used_space_shorten_ival(used_space_ival_t *ival, size_t count)
-{
-	assert(count > 0);
-	assert(count < ival->count);
-
-	ival->used_space->pages -= ival->count - count;
-	ival->count = count;
-}
-
 /** Mark portion of address space area as used.
  *
  * The address space area must be already locked.
  *
- * @param used_space Used space map
- * @param page First page to be marked.
+ * @param area  Address space area.
+ * @param page  First page to be marked.
  * @param count Number of page to be marked.
  *
